#!/bin/bash
#SBATCH --job-name sc10x.dispatch
#SBATCH -p 256GB,256GBv1,384GB
#SBATCH -N 1
#SBATCH -t 7-0:0:0
#SBATCH -o job_%j.out
#SBATCH -e job_%j.out
#SBATCH --mail-type ALL
#SBATCH --mail-user gervaise.henry@utsouthwestern.edu

git pull origin Seurat3.0
rm ../analysis/*.rda
rm ../analysis/*.RData
rm -r ../analysis/cor/
rm -r ../analysis/qc/
rm -r ../analysis/score_id/
rm -r ../analysis/shiny/
rm -r ../analysis/vis/

module load python/3.6.4-anaconda 
source activate umap
module load R/3.5.1-gccmkl
module load hdf5_18/1.8.17
Rscript ../r.scripts/sc-TissueMapper_RUN.R --p "$1" --s "$2"

module unload R/3.5.1-gccmkl
module load R/3.6.1-gccmkl
if [[ "$1" == "huPr_PdPgb" ]] || [[ "$1" == "huPr_PdPb" ]] || [[ "$1" == "huBl" ]]
then
	Rscript ../r.scripts/SingleR.R --p "$1" --s "$2" --o "$3"
elif [[ "$1" == "muPrUr" ]]
then
	Rscript ../r.scripts/huPr_muPr.R --p "$1" --r "$3"
fi

module unload R/3.5.1-gccmkl
module load R/3.6.1-gccmkl
if [[ "$1" == "huPr_PdPgb" ]]
then
	Rscript ../r.scripts/diy_PdPgb.R
elif [[ "$1" == "muPrUr" ]]
then
	Rscript ../r.scripts/diy_muPrUr_Epi.R
fi
