source("./r.scripts/sc-TissueMapper_functions.R")
source("./r.scripts/sc-TissueMapper_process.R")

# gene.set1 <- read_delim("./genesets/DEG_Epi_5FC.txt","\t",escape_double=FALSE,trim_ws=TRUE,col_names=FALSE)
# gene.set1 <- as.list(gene.set1)
# names(gene.set1) <- "Epi"
# gene.set <- c(gene.set1)
# gene.set1 <- read_delim("./genesets/DEG_FMSt_5FC.txt","\t",escape_double=FALSE,trim_ws=TRUE,col_names=FALSE)
# gene.set1 <- as.list(gene.set1)
# names(gene.set1) <- "St"
# gene.set <- c(gene.set,gene.set1)

gene.set1 <- read_delim("./genesets/genes.deg.BE.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "BE"
#gene.set <- c(gene.set,gene.set1)
gene.set <- c(gene.set1)
gene.set1 <- read_delim("./genesets/genes.deg.LE.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "LE"
gene.set <- c(gene.set,gene.set1)
gene.set1 <- read_delim("./genesets/genes.deg.OE1.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "Club"
gene.set <- c(gene.set,gene.set1)
gene.set1 <- read_delim("./genesets/genes.deg.OE2.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "Hillock"
gene.set <- c(gene.set,gene.set1)

gene.set1 <- read_delim("./genesets/genes.deg.NE.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "NE"
gene.set <- c(gene.set,gene.set1)

gene.set1 <- read_delim("./genesets/genes.deg.Endo.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "Endo"
gene.set <- c(gene.set,gene.set1)
gene.set1 <- read_delim("./genesets/genes.deg.SM.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "SM"
gene.set <- c(gene.set,gene.set1)
gene.set1 <- read_delim("./genesets/genes.deg.Fib.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
gene.set1 <- gene.set1[1]
gene.set1 <- as.list(gene.set1)
names(gene.set1) <- "Fib"
gene.set <- c(gene.set,gene.set1)

#gene.set1 <- read_delim("./genesets/genes.deg.Leu.csv",",",escape_double=FALSE,trim_ws=TRUE,col_names=TRUE)
#gene.set1 <- gene.set1[1]
#gene.set1 <- as.list(gene.set1)
#names(gene.set1) <- "Leu"
#gene.set <- c(gene.set,gene.set1)

gene.set1 <- read_excel("./genesets/nmeth.3337-S2.xls",sheet="SuppTable1_DEGs",skip=2)
colnames(gene.set1) <-  gsub(" ","_",colnames(gene.set1))
for (i in 2:ncol(gene.set1)){
  gene.set1[gene.set1[,i]==1,i] <- gene.set1[gene.set1[,i]==1,1]
}
rm(i)
gene.set1 <- gene.set1[,-1]
gene.set1 <- lapply(gene.set1,unlist)
gene.set1 <- lapply(gene.set1, function(x) {x[x!=0]})
gene.set2 <- NULL
for (i in 1:22){
  if (i<=12){
    gene.set2 <- c(gene.set2,list(gene.set1[[i]][!gene.set1[[i]] %in% unique(unlist(gene.set1[1:12][-i]))]))
  } else {
    gene.set2 <- c(gene.set2,list(gene.set1[[i]][!gene.set1[[i]] %in% unique(unlist(gene.set1[13:22][-i]))]))
  }
}
gene.set2 <- setNames(gene.set2,names(gene.set1))
gene.set <- c(gene.set,gene.set1)

gene.set.lin <- gene.set
names(gene.set.lin)[1:5] <- "Epi"
names(gene.set.lin)[6:8] <- "St"
names(gene.set.lin)[9:30] <- "Leu"

gene.set.epi <- gene.set[1:5]
gene.set.st <- gene.set[6:8]

gene.set.leu.lin <- gene.set[9:30]
names(gene.set.leu.lin)[1:12] <- "Lymphoid"
names(gene.set.leu.lin)[13:22] <- "Myeloid"

gene.set.lym <- gene.set[9:20]
# names(gene.set.lym)[1:2] <- "B cells"
# names(gene.set.lym)[3] <- "Plasma cells"
# names(gene.set.lym)[3] <- "CD8 T cells"
# names(gene.set.lym)[5:9] <- "CD4 T cells"
# names(gene.set.lym)[10] <- "Gamma delta T cells"

gene.set.myl <- gene.set[21:30]
# names(gene.set.lym)[1:4] <- "Monocytes and Macrophages"
# names(gene.set.lym)[5:6] <- "Dendritic cells"
# names(gene.set.lym)[7:8] <- "Mast cells"
# names(gene.set.lym)[9] <- "Eosinophil"
# names(gene.set.lym)[10] <- "Neutrophil"

rm(gene.set1)

results <- scQuSAGE(sc10x,gs=gene.set,save=TRUE,type="lg",id="integrated_snn_res.5",ds=0,nm="ALL",print="2")
sc10x <- results[[1]]
results.cor.lin <- results[[2]]
results.clust.lin.id <- results[[3]]
rm(results)

results <- scQuSAGE(sc10x,gs=gene.set.lin,save=TRUE,type="lg",id="integrated_snn_res.0.1",ds=0,nm="lin",print="2")
sc10x <- results[[1]]
results.cor.lin <- results[[2]]
results.clust.lin.id <- results[[3]]
rm(results)

sc10x.epi <- scSubset(sc10x,i="lin","Epi")
sc10x.st <- scSubset(sc10x,i="lin","St")
sc10x.leu <- scSubset(sc10x,i="lin","Leu")

results <- scPC(sc10x.epi,pc=100,hpc=0.9,file="epi",print="2")
sc10x.epi <- results[[1]]
pc.use.epi <- results[[2]]
rm(results)
sc10x.epi <- scCluster(sc10x.epi,res=res,red="pca",dim=pc.use.epi,print="2",folder="epi")

results <- scPC(sc10x.st,pc=100,hpc=0.9,file="st",print="2")
sc10x.st <- results[[1]]
pc.use.st <- results[[2]]
rm(results)
sc10x.st <- scCluster(sc10x.st,res=res,red="pca",dim=pc.use.st,print="2",folder="st")

results <- scPC(sc10x.leu,pc=100,hpc=0.9,file="leu",print="2")
sc10x.leu <- results[[1]]
pc.use.leu <- results[[2]]
rm(results)
sc10x.leu <- scCluster(sc10x.leu,res=res,red="pca",dim=pc.use.leu,print="2",folder="leu.lin")

results <- scQuSAGE(sc10x.epi,gs=gene.set.epi,save=TRUE,type="lg",id="integrated_snn_res.0.5",ds=0,nm="epi",print="2")
sc10x.epi <- results[[1]]
results.cor.epi <- results[[2]]
results.clust.epi.id <- results[[3]]
rm(results)

results <- scQuSAGE(sc10x.st,gs=gene.set.st,save=TRUE,type="lg",id="integrated_snn_res.0.5",ds=0,nm="st",print="2")
sc10x.st <- results[[1]]
results.cor.st <- results[[2]]
results.clust.st.id <- results[[3]]
rm(results)

results <- scQuSAGE(sc10x.leu,gs=gene.set.leu.lin,save=TRUE,type="lg",id="integrated_snn_res.0.5",ds=0,nm="leu.lin",print="2")
sc10x.leu.lin <- results[[1]]
results.cor.leu.lin <- results[[2]]
results.clust.leu.lin.id <- results[[3]]
rm(results)

sc10x.lym <- scSubset(sc10x.leu.lin,i="leu.lin","Lymphoid")
sc10x.myl <- scSubset(sc10x.leu.lin,i="leu.lin","Myeloid")

results <- scPC(sc10x.lym,pc=100,hpc=0.9,file="lym",print="2")
sc10x.lym <- results[[1]]
pc.use.lym <- results[[2]]
rm(results)
sc10x.lym <- scCluster(sc10x.lym,res=res,red="pca",dim=pc.use.lym,print="2",folder="lym")

results <- scPC(sc10x.myl,pc=100,hpc=0.9,file="myl",print="2")
sc10x.myl <- results[[1]]
pc.use.myl <- results[[2]]
rm(results)
sc10x.myl <- scCluster(sc10x.myl,res=res,red="pca",dim=pc.use.myl,print="2",folder="myl")

results <- scQuSAGE(sc10x.lym,gs=gene.set.lym,save=TRUE,type="lg",id="integrated_snn_res.1",ds=0,nm="lym",print="2")
sc10x.lym <- results[[1]]
results.cor.lym <- results[[2]]
results.clust.lym.id <- results[[3]]
rm(results)

results <- scQuSAGE(sc10x.myl,gs=gene.set.myl,save=TRUE,type="sm",id="integrated_snn_res.1",ds=0,nm="myl",print="2")
sc10x.myl <- results[[1]]
results.cor.myl <- results[[2]]
results.clust.myl.id <- results[[3]]
rm(results)

Idents(sc10x) <- "integrated_snn_res.0.1"
for (i in unique(Idents(sc10x.epi))){
  Idents(sc10x,cells=WhichCells(sc10x.epi,idents=i)) <- i
}
for (i in unique(Idents(sc10x.st))){
  Idents(sc10x,cells=WhichCells(sc10x.st,idents=i)) <- i
}
for (i in unique(Idents(sc10x.lym))){
  Idents(sc10x,cells=WhichCells(sc10x.lym,idents=i)) <- i
}
for (i in unique(Idents(sc10x.myl))){
  Idents(sc10x,cells=WhichCells(sc10x.myl,idents=i)) <- i
}
sc10x$ALL.POPS <- Idents(sc10x)
if (!dir.exists(paste0("./analysis/vis/ALL.POPS"))){
  dir.create(paste0("./analysis/vis/ALL.POPS"))
}
plot1 <- DimPlot(sc10x,reduction="pca",label=TRUE,repel=TRUE)+theme(legend.position="none")
plot2 <- DimPlot(sc10x,reduction="tsne",label=TRUE,repel=TRUE)+theme(legend.position="none")
plot3 <- DimPlot(sc10x,reduction="umap",label=TRUE,repel=TRUE)+theme(legend.position="none")
postscript(paste0("./analysis/vis/ALL.POPS/2Vis_merge_ALL.POPS.eps"))
grid.arrange(plot2,plot3,ncol=1)
dev.off()
rm(plot1)
rm(plot2)
rm(plot3)

save(list=ls(pattern="^sc10x"),file=paste0("./analysis/",project.name,".rda"))
save.image(file="./analysis/Data.RData")